Index: romio/adio/ad_pvfs2/ad_pvfs2_delete.c
===================================================================
RCS file: /home/MPI/cvsMaster/romio/adio/ad_pvfs2/ad_pvfs2_delete.c,v
retrieving revision 1.5
retrieving revision 1.8
--- romio/adio/ad_pvfs2/ad_pvfs2_delete.c	5 Sep 2003 20:43:58 -0000	1.5
+++ romio/adio/ad_pvfs2/ad_pvfs2_delete.c	20 May 2004 20:31:05 -0000	1.8
@@ -1,62 +1,52 @@
 /* -*- Mode: C; c-basic-offset:4 ; -*- */
 /* 
- *   $Id: ad_pvfs2_delete.c,v 1.5 2003/09/05 20:43:58 robl Exp $    
+ *   $Id: ad_pvfs2_delete.c,v 1.8 2004/05/20 20:31:05 robl Exp $    
  *
  *   Copyright (C) 2003 University of Chicago. 
  *   See COPYRIGHT notice in top-level directory.
  */
 
 #include "ad_pvfs2.h"
 #include "adio.h"
 
 #include "ad_pvfs2_common.h"
 
 void ADIOI_PVFS2_Delete(char *filename, int *error_code)
 {
     PVFS_credentials credentials;
     PVFS_sysresp_getparent resp_getparent;
-    int ret, i, mnt_index;
+    int ret;
+    PVFS_fs_id cur_fs;
     char pvfs_path[PVFS_NAME_MAX] = {0};
 
     ADIOI_PVFS2_Init(error_code);
     if (*error_code != MPI_SUCCESS) 
     {
 	ADIOI_PVFS2_pvfs_error_convert(0, error_code);
 	return;
     }
 
     /* in most cases we'll store the credentials in the fs struct, but we don't
      * have one of those in Delete  */
     ADIOI_PVFS2_makecredentials(&credentials);
 
     /* given the filename, figure out which pvfs filesystem it is on */
-    for (i=0; i<ADIOI_PVFS2_mntlist.ptab_count; i++) {
-	ret = PVFS_util_remove_dir_prefix(filename, 
-		ADIOI_PVFS2_mntlist.ptab_array[i].mnt_dir, 
-		pvfs_path, PVFS_NAME_MAX);
-	if (ret == 0) {
-	    mnt_index = i;
-	    break;
-	}
-    }
-    if (mnt_index == -1) {
-	fprintf(stderr, "Error: could not find filesystem for %s in pvfstab",
-		filename);
+    ret = PVFS_util_resolve(filename, &cur_fs, pvfs_path, PVFS_NAME_MAX);
+    if (ret < 0) {
+	PVFS_perror("PVFS_util_resolve", ret);
 	/* TODO: pick a good error for this */
 	ret = -1;
 	goto resolve_error;
     }
-
-    ret = PVFS_sys_getparent(ADIOI_PVFS2_fs_id_list[mnt_index], pvfs_path,
-	    credentials, &resp_getparent);
+    ret = PVFS_sys_getparent(cur_fs, pvfs_path, &credentials, &resp_getparent);
 
     ret = PVFS_sys_remove(resp_getparent.basename, 
-	    resp_getparent.parent_refn, credentials);
+	    resp_getparent.parent_ref, &credentials);
     if (ret < 0) {
 	/* XXX: better error handling */
 	ADIOI_PVFS2_pvfs_error_convert(ret, error_code);
 	return;
     }
     *error_code = MPI_SUCCESS;
     return;
 
Index: romio/adio/ad_pvfs2/ad_pvfs2_fcntl.c
===================================================================
RCS file: /home/MPI/cvsMaster/romio/adio/ad_pvfs2/ad_pvfs2_fcntl.c,v
retrieving revision 1.3
retrieving revision 1.5
--- romio/adio/ad_pvfs2/ad_pvfs2_fcntl.c	5 Aug 2003 22:59:20 -0000	1.3
+++ romio/adio/ad_pvfs2/ad_pvfs2_fcntl.c	20 May 2004 20:31:05 -0000	1.5
@@ -1,11 +1,11 @@
 /* -*- Mode: C; c-basic-offset:4 ; -*- */
 /* 
- *   $Id: ad_pvfs2_fcntl.c,v 1.3 2003/08/05 22:59:20 robl Exp $    
+ *   $Id: ad_pvfs2_fcntl.c,v 1.5 2004/05/20 20:31:05 robl Exp $    
  *
  *   Copyright (C) 1997 University of Chicago. 
  *   See COPYRIGHT notice in top-level directory.
  */
 
 #include "ad_pvfs2.h"
 #include "adio_extern.h"
 #include "ad_pvfs2_common.h"
@@ -16,18 +16,18 @@
     ADIOI_PVFS2_fs *pvfs_fs;
     PVFS_sysresp_getattr resp_getattr;
 
     pvfs_fs = (ADIOI_PVFS2_fs*)fd->fs_ptr;
 
     switch(flag) {
 
     case ADIO_FCNTL_GET_FSIZE:
-	ret = PVFS_sys_getattr(pvfs_fs->pinode_refn, PVFS_ATTR_SYS_SIZE, 
-		pvfs_fs->credentials, &resp_getattr);
+	ret = PVFS_sys_getattr(pvfs_fs->object_ref, PVFS_ATTR_SYS_SIZE, 
+		&(pvfs_fs->credentials), &resp_getattr);
 	if (ret < 0 ) {
 	    ADIOI_PVFS2_pvfs_error_convert(ret, error_code);
 	} else {
 	    *error_code = MPI_SUCCESS;
 	}
 	fcntl_struct->fsize = resp_getattr.attr.size;
 	return;
 
Index: romio/adio/ad_pvfs2/ad_pvfs2_flush.c
===================================================================
RCS file: /home/MPI/cvsMaster/romio/adio/ad_pvfs2/ad_pvfs2_flush.c,v
retrieving revision 1.3
retrieving revision 1.9
--- romio/adio/ad_pvfs2/ad_pvfs2_flush.c	30 Oct 2003 18:53:40 -0000	1.3
+++ romio/adio/ad_pvfs2/ad_pvfs2_flush.c	20 May 2004 20:31:05 -0000	1.9
@@ -1,41 +1,49 @@
 /* -*- Mode: C; c-basic-offset:4 ; -*- */
 /* 
- *   $Id: ad_pvfs2_flush.c,v 1.3 2003/10/30 18:53:40 robl Exp $    
+ *   $Id: ad_pvfs2_flush.c,v 1.9 2004/05/20 20:31:05 robl Exp $    
  *
  *   Copyright (C) 1997 University of Chicago. 
  *   See COPYRIGHT notice in top-level directory.
  */
 
 #include "ad_pvfs2.h"
 #include "ad_pvfs2_common.h"
 
-/* we want to be a bit clever here:  at scale, every client sending a flush
- * will stress the server unnecessarily.  One process should wait for everyone
- * to catch up, do the sync, then broadcast the result.
+/* we want to be a bit clever here:  at scale, if every client sends a
+ * flush request, it will stress the PVFS2 servers with redundant
+ * PVFS_sys_flush requests.  Instead, one process should wait for
+ * everyone to catch up, do the sync, then broadcast the result.  We can
+ * get away with this thanks to PVFS2's stateless design 
  */
+
 void ADIOI_PVFS2_Flush(ADIO_File fd, int *error_code)
 {
-    int ret, rank, tmprank, dummy1, dummy2;
+    int ret, rank, dummy=0, dummy_in=0; 
     ADIOI_PVFS2_fs *pvfs_fs;
 
     *error_code = MPI_SUCCESS;
 
     pvfs_fs = (ADIOI_PVFS2_fs*)fd->fs_ptr;
 
     MPI_Comm_rank(fd->comm, &rank);
 
-    /* the cheapest way we know to let one process know everyone is here */
-    MPI_Gather(&dummy1, 1, MPI_INT, &dummy2, 1, MPI_INT, 0, fd->comm);
 
-    if (rank == 0) {
-	ret = PVFS_sys_flush(pvfs_fs->pinode_refn, pvfs_fs->credentials);
+    /* unlike ADIOI_PVFS2_Resize, MPI_File_sync() does not perform any
+     * syncronization */
+    MPI_Reduce(&dummy_in, &dummy, 1, MPI_INT, MPI_SUM, 
+	    fd->hints->ranklist[0], fd->comm);
+
+    /* io_worker computed in ADIO_Open */
+    if (rank == fd->hints->ranklist[0]) {
+	ret = PVFS_sys_flush(pvfs_fs->object_ref, &(pvfs_fs->credentials));
 	MPI_Bcast(&ret, 1, MPI_INT, 0, fd->comm);
-    }
+    } else {
     MPI_Bcast(&ret, 1, MPI_INT, 0, fd->comm);
+    }
     if (ret < 0)
 	ADIOI_PVFS2_pvfs_error_convert(ret, error_code);
 }
 
 /* 
  * vim: ts=8 sts=4 sw=4 noexpandtab 
  */
Index: romio/adio/ad_pvfs2/ad_pvfs2_open.c
===================================================================
RCS file: /home/MPI/cvsMaster/romio/adio/ad_pvfs2/ad_pvfs2_open.c,v
retrieving revision 1.11
retrieving revision 1.14
--- romio/adio/ad_pvfs2/ad_pvfs2_open.c	2 Nov 2003 15:55:18 -0000	1.11
+++ romio/adio/ad_pvfs2/ad_pvfs2_open.c	20 May 2004 20:31:05 -0000	1.14
@@ -1,22 +1,22 @@
 /* -*- Mode: C; c-basic-offset:4 ; -*-
  * vim: ts=8 sts=4 sw=4 noexpandtab
- *   $Id: ad_pvfs2_open.c,v 1.11 2003/11/02 15:55:18 rross Exp $
+ *   $Id: ad_pvfs2_open.c,v 1.14 2004/05/20 20:31:05 robl Exp $
  *
  *   Copyright (C) 1997 University of Chicago. 
  *   See COPYRIGHT notice in top-level directory.
  */
 
 #include "ad_pvfs2.h"
 #include "ad_pvfs2_common.h"
 
 struct open_status_s {
     int error;
-    PVFS_pinode_reference pinode_refn;
+    PVFS_object_ref object_ref;
 };
 typedef struct open_status_s open_status;
     
     /* steps for getting a handle:  (it gets a little convoluted, but at least
      * it's deterministic) 
      * . lookup the file.  
      * . if lookup succeeds, but we were passed MPI_MODE_EXCL, that's an error
      * . if lookup fails, the file might not exist. 
@@ -39,128 +39,123 @@
 
     ADIOI_PVFS2_makeattribs(&attribs);
 
     memset(&resp_lookup, 0, sizeof(resp_lookup));
     memset(&resp_getparent, 0, sizeof(resp_getparent));
     memset(&resp_create, 0, sizeof(resp_create));
 
     ret = PVFS_sys_lookup(fs_id, pvfs_name,
-	    pvfs2_fs->credentials, &resp_lookup, PVFS2_LOOKUP_LINK_FOLLOW);
+	    &(pvfs2_fs->credentials), &resp_lookup, PVFS2_LOOKUP_LINK_FOLLOW);
     if ( (ret < 0) ) { /* XXX: check what the error was */
 	if (access_mode & MPI_MODE_CREATE)  {
 	    ret = PVFS_sys_getparent(fs_id, pvfs_name,
-		    pvfs2_fs->credentials, &resp_getparent); 
+		    &(pvfs2_fs->credentials), &resp_getparent); 
 	    if (ret < 0) {
 		fprintf(stderr, "pvfs_sys_getparent returns with %d\n", ret);
 		o_status->error = ret;
 		return;
 	    } 
 	    ret = PVFS_sys_create(resp_getparent.basename, 
-		    resp_getparent.parent_refn, attribs, 
-		    pvfs2_fs->credentials, &resp_create); 
+		    resp_getparent.parent_ref, attribs, 
+		    &(pvfs2_fs->credentials), NULL, &resp_create); 
 
 	    if (ret < 0) { /* XXX: should only do this for EEXISTS */
 		ret = PVFS_sys_lookup(fs_id, pvfs_name,
-			pvfs2_fs->credentials, &resp_lookup, 
+			&(pvfs2_fs->credentials), &resp_lookup, 
 			PVFS2_LOOKUP_LINK_FOLLOW);
 		if ( ret < 0 ) {
 		    o_status->error = ret;
 		    return;
 		}
 		o_status->error = ret;
-		o_status->pinode_refn = resp_lookup.pinode_refn;
+		o_status->object_ref = resp_lookup.ref;
 		return;
 	    }
-	    o_status->pinode_refn = resp_create.pinode_refn;
+	    o_status->object_ref = resp_create.ref;
 	} else {
 	    fprintf(stderr, "cannot create file without MPI_MODE_CREATE\n");
 	    o_status->error = ret;
 	    return;
 	}
     } else if (access_mode & MPI_MODE_EXCL) {
 	/* lookup should not succeed if opened with EXCL */
 	o_status->error = -1; /* XXX: what should it be? */
 	return;
     } else {
-	o_status->pinode_refn = resp_lookup.pinode_refn;
+	o_status->object_ref = resp_lookup.ref;
     }
     o_status->error = ret;
     return;
 
 }
 
 
 /* if MPI_File_open was called with MPI_MODE_CREATE|MPI_MODE_EXCL, then we have
  * a little problem: our usual open-and-broadcast test will not work because
  * only one person (the first aggregator) will perform the open w/ CREATE|EXCL
  */
 void ADIOI_PVFS2_Open(ADIO_File fd, int *error_code)
 {
-    int rank, ret, i, mnt_index=-1;
+    int rank, ret;
+    PVFS_fs_id cur_fs;
     char pvfs_path[PVFS_NAME_MAX] = {0};
 
     ADIOI_PVFS2_fs *pvfs2_fs;
 
     /* since one process is doing the open, that means one process is also
-     * doing the error checking.  define a struct for both the pinode and the
-     * error code to broadcast to all the processors */
+     * doing the error checking.  define a struct for both the object reference
+     * and the error code to broadcast to all the processors */
 
     open_status o_status;
     MPI_Datatype open_status_type;
     MPI_Datatype types[2] = {MPI_INT, MPI_BYTE};
-    int lens[2] = {1, sizeof(PVFS_pinode_reference)};
+    int lens[2] = {1, sizeof(PVFS_object_ref)};
     MPI_Aint offsets[2];
     
     pvfs2_fs = (ADIOI_PVFS2_fs *)ADIOI_Malloc(sizeof(ADIOI_PVFS2_fs));
     if (pvfs2_fs == NULL) {
 	/* graceful way to handle out of memory? */
 	ADIOI_PVFS2_pvfs_error_convert(0, error_code);
 	return;
     }
 
     MPI_Comm_rank(fd->comm, &rank);
 
     MPI_Address(&o_status.error, &offsets[0]);
-    MPI_Address(&o_status.pinode_refn, &offsets[1]);
+    MPI_Address(&o_status.object_ref, &offsets[1]);
 
     MPI_Type_struct(2, lens, offsets, types, &open_status_type);
     MPI_Type_commit(&open_status_type);
 
     ADIOI_PVFS2_Init(error_code);
     if (*error_code != MPI_SUCCESS)
     {
-	/* XXX: handle errors */
+	ADIOI_PVFS2_pvfs_error_convert(0, error_code);
 	return;
     }
 
     ADIOI_PVFS2_makecredentials(&(pvfs2_fs->credentials));
 
     /* we only have to do this on one node. we'll broadcast the handle to
      * everyone else in the communicator */
 
     if (rank == fd->hints->ranklist[0]) {
 	/* given the filename, figure out which pvfs filesystem it is on */
-	for(i=0; i<ADIOI_PVFS2_mntlist.ptab_count; i++) {
-	    ret = PVFS_util_remove_dir_prefix(fd->filename, 
-		    ADIOI_PVFS2_mntlist.ptab_array[i].mnt_dir, 
+	ret = PVFS_util_resolve(fd->filename, &cur_fs, 
 		    pvfs_path, PVFS_NAME_MAX);
-	    if (ret == 0) {
-		mnt_index = i;
-		break;
-	    }
-	}
-	if (mnt_index == -1) {
-	    fprintf(stderr, "Error: could not find filesystem for %s in pvfstab", fd->filename);
+	if (ret < 0 ) {
+	    PVFS_perror("PVFS_util_resolve", ret);
 	    /* TODO: pick a good error for this */
 	    o_status.error = -1;
-	} else 
-	    fake_an_open(ADIOI_PVFS2_fs_id_list[mnt_index], pvfs_path,
+	} else  {
+	    fake_an_open(cur_fs, pvfs_path,
 		    fd->access_mode, pvfs2_fs, &o_status);
     }
+    }
 
     /* NOTE: if MPI_MODE_EXCL was set, ADIO_Open will call
      * ADIOI_PVFS2_Open from just one processor.  This really confuses MPI when
      * one procesor on a communicator broadcasts to no listners.  
      *
      * Since ADIO_Open will close the file and call ADIOI_PVFS2_Open again (but
      * w/o EXCL), we can bail out right here and return early */
     if ( (fd->access_mode & MPI_MODE_EXCL)  ) {
@@ -170,25 +165,25 @@
 	} else {
 	    ADIOI_Free(pvfs2_fs);
 	    ADIOI_PVFS2_pvfs_error_convert(o_status.error, error_code);
 	} 
 	MPI_Type_free(&open_status_type);
 	return;
     } 
 
-    /* broadcast status and (if successful) valid pinode refn */
+    /* broadcast status and (if successful) valid object reference */
     MPI_Bcast(MPI_BOTTOM, 1, open_status_type, 0, fd->comm);
 
     if (o_status.error != 0 ) { 
 	ADIOI_Free(pvfs2_fs);
 	ADIOI_PVFS2_pvfs_error_convert(o_status.error, error_code);
 	return;
     }
 
-    pvfs2_fs->pinode_refn = o_status.pinode_refn;
+    pvfs2_fs->object_ref = o_status.object_ref;
     fd->fs_ptr = pvfs2_fs;
 
     MPI_Type_free(&open_status_type);
 
     *error_code = MPI_SUCCESS;
     return;
 }
